  \version "2.11.56"

  \paper {  #(define page-breaking ly:minimal-breaking) % 1er algo
    %% Translate the TOC title
    tocTitle = "TABLE DES MATIERES"
    between-system-padding = #4.5
    ragged-bottom = ##t
    ragged-last-bottom = ##t
  }

  \include "0-book-titling-Art-Libre-du-Batteur.ily"
  \include "0-mydrums-style2.ly"

 #(ly:set-option 'delete-intermediate-files #t)

  \header {    
    title = \markup { \column  { \center-align { \fontsize #-1  \bold "L' ART LIBRE"  }
      \line { \center-align {  \fontsize #-1  \bold " DU "  } }
      \line { \center-align {  \fontsize #-1  \bold " BATTEUR "  } } 
      \line { \center-align {  \fontsize #-1  \bold " ~~~~~~~ "  } }
      \line { \center-align { \fontsize #-1  \bold " (THE DRUMMER'S"  } }
      \line { \center-align { \fontsize #-1  \bold " FREE ART)"  } } } }

    date = "Version du 12/09/2008"

    copyright =  \markup { \fontsize #3  \bold  \override #'(box-padding . 1.0) \override #'(baseline-skip . 2.7) \box  \column { \center-align { \fontsize #-2 \line {  • \hspace #0.5 Copyleft: cette oeuvre est libre, vous pouvez la copier, la diffuser et la modifier. }  \line { \fontsize #-2 \line { Créé avec LilyPond 2.11.56   \with-url #"http://www.LilyPond.org" \line { \with-color #blue \fontsize #-1 www. \hspace #-1.0 \with-color #blue LilyPond \hspace #-1.0 \with-color #blue \fontsize #-1 .org } par travail collectif. } } \line { \fontsize #-4 \line {Copyleft 09/2008: selon les termes de la Licence Art Libre , voir: \hspace #-0.5 \with-url #"http://www.artlibre.org"  \with-color #blue  http://www.artlibre.org  } } } } } 

 
    tagline =  \markup { \fontsize #3  \bold   \override #'(box-padding . 1.0) \override #'(baseline-skip . 2.7) \box  \column { \center-align { \fontsize #-2 \line {  • \hspace #0.5 Copyleft: cette oeuvre est libre, vous pouvez la copier, la diffuser et la modifier. }  \line { \fontsize #-2 \line { Créé avec LilyPond 2.11.56   \with-url #"http://www.LilyPond.org" \line { \with-color #blue \fontsize #-1 www. \hspace #-1.0 \with-color #blue LilyPond \hspace #-1.0 \with-color #blue \fontsize #-1 .org } par travail collectif. } } \line { \fontsize #-4 \line {Copyleft 09/2008: selon les termes de la Licence Art Libre , voir: \hspace #-0.5 \with-url #"http://www.artlibre.org"  \with-color #blue  http://www.artlibre.org  } } } } }

  }


  \bookTitle "L'Art Libre du Batteur"
  %% set to #f to turn off piece numbering
  \useRehearsalNumbers ##f

  % Pour avoir une page blanche
  \pageBreak

  \markup { \fill-line { \override #'(line-width . 80)
 \justify-string #"" } }

  %% Table of contents
  \pageBreak
  \markuplines \table-of-contents

  \pageBreak

 \titledPiece \markup "Notes pour l'utilisateur."
  \markup {   \column { \fill-line { 
  \override #'(line-width . 80)
 \fontsize #3 \justify-string #"Voici quelques façons d'utiliser les patterns:

-- AVEC LES SOURCES:

	Avec le Pdf, en positionnant la souris sur une note, vous verrez apparaitre une fenêtre pop-up qui vous donnera le numéro de la ligne correspondant dans le fichier source. C'est le chemin le plus facile pour sélectionner dans la source ce qui vous intéresse.

	Recopiez des mesures choisies dans le modèle fourni:  01-modele-patterns-1voix.ly  pour faire votre propre montage, puis recompilez en ligne de commande. Attention! Si vous faites des changements de mesure, il faut rajouter  \\time n/n  avant la mesure concernée.

	Exemple:

	\\time 4/4

	<bd hhc>8 hhc8 <ss hhc>8 <bd hhc>16 hhc <bd hhc>8 hhc8 <ss hhc>8 <bd hhc>8 |

	\\time 7/8

	<bd hhc>8 hhc8 <bd ss hhc>16 hhc <bd hhc>8 hhc8 <ss hhc>8 <bd hhc>8 |

	etc ...

	... sinon vous aurez beaucoup d'erreurs à la compilation et au mieux un Pdf illisible. Tous les chiffrages imaginables sont possibles mais écrivez des mesures complètes, solfège oblige, en les complétant par des silences, si nécessaire.

	Vous pouvez changer le tempo d'un pattern à n'importe quel endroit, faire des ralentis ou des accelerando. Comme pour le chiffrage des mesures il suffit d'insérer des \\tempo = n à l'endroit voulu. Si vous faites un tel changement au tout début d'un morceau, autant éditer aussi le bloc midi plus bas, là où est écrit:" }  }  }
	
  \pageBreak
	
  \markup {   \column { \fill-line { 
  \override #'(line-width . 80)
 \fontsize #3 \justify-string #"

    	tempoWholesPerMinute = #(ly:make-moment n n)

	Cela vous évitera d'avoir une marque de tempo inutile au début de votre fichier Midi.
	
-- AVEC LE MIDI:
	
	Le seul inconvénient dans l'utilisation de Lilypond est la perte des valeurs précises des vélocités. Mais quoi? Ouvrez un séquenceur. Importez le fichier Midi. Créez une ou plusieurs nouvelles pistes. Ouvrez l'éditeur de batterie. Copiez-collez la mesure qui vous intéresse et, en un tour de main, personnalisez les vélocités avant de faire les duplications nécessaires pour votre morceau. Indispensable. Par exemple pour les notes fantômes (les ghost notes. voir: Swing). Vous pourrez aussi décaler légèrement avant ou après le temps les notes de votre choix, etc...

 	Grace au midi vous pouvez ne copier dans une nouvelle piste que la cymbale d'un pattern. N'oubliez pas les vélocités.

	Tous les patterns sont routés vers le kit standard. Vous pouvez choisir un autre drumkit en vous servant de la liste ci-dessous qui provient des sources de Lilypond . Choisissez uniquement le nom du drumkit et mettez-le dans : 

	\\set Staff.midiInstrument = \"\"   

	(la liste provient de midi.scm)

	  ; (channel 10 drum-kits - subtract 32768 to get program no.)

	  (\"standard kit\" .     ,(+ 32768 0))

	  (\"standard drums\" .   ,(+ 32768 0))

	  (\"drums\" .            ,(+ 32768 0))

	  (\"room kit\" .         ,(+ 32768 8))

	  (\"room drums\" .       ,(+ 32768 8))

	  (\"power kit\" .        ,(+ 32768 16))

	  (\"power drums\" .      ,(+ 32768 16))

	  (\"rock drums\" .       ,(+ 32768 16))

	  "

	  } } }

  \markup {   \column { \fill-line { 
  \override #'(line-width . 80)
 \fontsize #3 \justify-string #"


	  (\"electronic kit\" .   ,(+ 32768 24))

	  (\"electronic drums\" . ,(+ 32768 24))

	  (\"tr-808 kit\" .       ,(+ 32768 25))

	  (\"tr-808 drums\" .     ,(+ 32768 25))

	  (\"jazz kit\" .         ,(+ 32768 32))

	  (\"jazz drums\" .       ,(+ 32768 32))

	  (\"brush kit\" .        ,(+ 32768 40))

	  (\"brush drums\" .      ,(+ 32768 40))

	  (\"orchestra kit\" .    ,(+ 32768 48))

	  (\"orchestra drums\" .  ,(+ 32768 48))

	  (\"classical drums\" .  ,(+ 32768 48))

	  (\"sfx kit\" .          ,(+ 32768 56))

	  (\"sfx drums\" .        ,(+ 32768 56))

	  (\"mt-32 kit\" .        ,(+ 32768 127))

	  (\"mt-32 drums\" .      ,(+ 32768 127))

	  (\"cm-64 kit\" .        ,(+ 32768 127))

	  (\"cm-64 drums\" .      ,(+ 32768 127))

	Vous pouvez aussi router les sorties du séquenceur vers Hydrogen...

	Vous pouvez également importer un fichier Midi dans Csound ou Pure Data et complètement changer les sonorités...

	Ayez du bonheur."  }  }  }

  \pageBreak

 \titledPiece \markup "Notes for the user."
  \markup {   \column { \fill-line { 
  \override #'(line-width . 80)
 \fontsize #3 \justify-string #"NOTES FOR THE USER.

Here are some ways to use this patterns:

-- WITH THE SOURCES:

	In the PDF document, point the mouse over a note; a pop-up window will
	appear, giving you the corresponding line number in the source
	file.  It is the easiest way to select the relevant piece of code in
	the source file.

	Copy the fragment you want in the included template:

	01-modele-patterns-1voix.ly
	
	edit it accordingly to your needs, then recompile it using the command 
	line.  Beware though:
	if you change the time signature, you will have to add   
	\\time n/n  before the appropriate bar.

	Example:

	\\time 4/4

	<bd hhc>8 hhc8 <ss hhc>8 <bd hhc>16 hhc <bd hhc>8 hhc8 <ss hhc>8 <bd hhc>8 |

	\\time 7/8

	<bd hhc>8 hhc8 <bd ss hhc>16 hhc <bd hhc>8 hhc8 <ss hhc>8 <bd hhc>8 |

	etc ...

	... otherwise you would get too many compiling errors, and the PDF 
	output would be unreadable for the best.  Any conceivable time signature
	is available, but you have to stick to basic music theory and write
	whole bars, completing them with rests when needed.

	You may change a pattern's tempo whenever you want, and make it slow
	down or speed up, as easily as its time signature: you only have to 
	insert   \\tempo = n    at the right place.  If you do such a change at
	the beginning of a piece, you may as well edit the midi block at the 
	bottom, where you can find: "

  }  }  }

  \markup {   \column { \fill-line { 
  \override #'(line-width . 80)
 \fontsize #3 \justify-string #"tempoWholesPerMinute = #(ly:make-moment n n)

	You'll avoid an useless mark tempo at the beginning of your midi file.
	
-- WITH MIDI:
	
	LilyPond's only drawback is that it does not handle precisely velocity
	values.  No big deal: open a sequencer.  Import the Midi file.  Create
	one or several new tracks.  Open the drum Editor. Paste the bar you're
	interested in; within seconds, you'll be able to customize the velocity
	before replicating them back in your song. This is mandatory:
	for instance with ghost notes (see: Swing).  Moreover, you will be able
	to shift a given note before or after the beat, etc.

	Thanks to Midi, you can precisely extract what you need, e.g. this 
	cymbal part you love, from the pattern to a new track.  Don't forget
	the velocities.

 	All the patterns are routed to the standard kit. You may want to choose
	another one, using the following list which was taken from Lilypond's
	sources. Set the drumkit's name as follows:

	\\set Staff.midiInstrument = \"\"   

	(the list comes from  midi.scm)

	  ; (channel 10 drum-kits - subtract 32768 to get program no.)

	  (\"standard kit\" .     ,(+ 32768 0))

	  (\"standard drums\" .   ,(+ 32768 0))

	  (\"drums\" .            ,(+ 32768 0))

	  (\"room kit\" .         ,(+ 32768 8))

	  (\"room drums\" .       ,(+ 32768 8))

	  (\"power kit\" .        ,(+ 32768 16))

	  (\"power drums\" .      ,(+ 32768 16))

	  (\"rock drums\" .       ,(+ 32768 16))

	  (\"electronic kit\" .   ,(+ 32768 24))

	  (\"electronic drums\" . ,(+ 32768 24))   "

  }  }  }

  \markup {   \column { \fill-line { 
  \override #'(line-width . 80)
 \fontsize #3 \justify-string #"	  

	  (\"tr-808 kit\" .       ,(+ 32768 25))

	  (\"tr-808 drums\" .     ,(+ 32768 25))

	  (\"jazz kit\" .         ,(+ 32768 32))

	  (\"jazz drums\" .       ,(+ 32768 32))

	  (\"brush kit\" .        ,(+ 32768 40))

	  (\"brush drums\" .      ,(+ 32768 40))

	  (\"orchestra kit\" .    ,(+ 32768 48))

	  (\"orchestra drums\" .  ,(+ 32768 48))

	  (\"classical drums\" .  ,(+ 32768 48))

	  (\"sfx kit\" .          ,(+ 32768 56))

	  (\"sfx drums\" .        ,(+ 32768 56))

	  (\"mt-32 kit\" .        ,(+ 32768 127))

	  (\"mt-32 drums\" .      ,(+ 32768 127))

	  (\"cm-64 kit\" .        ,(+ 32768 127))

	  (\"cm-64 drums\" .      ,(+ 32768 127))


	You can also route the sequencer output in Hydrogen...

	You can also import a midi file in Csound or Pure Data and change all 
	the tones...

	Have fun. "


  }  }  }

  \pageBreak
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \titledPiece \markup "Nomenclature."
pulse = \drummode { 
  \time 3/4 
  \tempo 4 = 60 

	bda4^"bda (Acoustic Bass Drum)" bd^"bd (Bass Drum 1)" ss^"ss (Side Stick)"
\break
	sna^"sna (Acoustic Snare)" hc^"hc (Hand clap)" sne^"sne (Electric Snare)"
\break
	tomfl^"tomfl (Low Floor Tom)" hhc^"hhc (Closed Hi-Hat)" tomfh^"tomfh (High Floot Tom)" 
\break
	hhp^"hhp (Pedal Hi-Hat)" toml^"toml (Low Tom)" hho^"hho (Open Hi-Hat)"
\break
	tomml^"tomml (Low Mid Tom)" tommh^"tommh (Hi Mid Tom)" cymca^"cymca (Crash Cymbal 1)"
\break
	tomh^"tomh (High Tom)" cymra^"cymra (Ride Cymbal 1)" cymch^"cymch (Chinese Cymbal)"
\break
	rb^"rb (Ride Bell)" tamb^"tamb (Tambourine)" cyms^"cyms (Splash Cymbal)"
\break
	cb^"cb (Cowbell)" cymcb^"cymcb (Crash Cymbal 2)" vibs^"vibs (Vibraslap)"
\break
	cymrb^"cymrb (Ride Cymbal 2)" r2
\break

	boh4^"boh (Hi Bongo)" bol^"bol (Low Bongo)" cghm^"cghm (Mute Hi Conga)" 
\break
	cgho^"cgho Open Hi Conga)" cgl^"cgl (Low Conga)" timh^"timh (High Timbale)"
\break
	timl^"timl (Low Timbale)" agh^"agh (High Agogo)" agl^"agl (Low Agogo)" 
\break
	cab^"cab (Cabasa)" mar^"mar (Maracas)" whs^"whs (Short Whistle)"
\break
	whl^"whl (Long Whistle)" guis^"guis (Short Guiro)" guil^"guil (Long Guiro)"
\break
	cl^"cl (Claves)" wbh^"wbh (Hi Wood Block=" wbl^"wbl (Low Wood Block)"
\break
	cuim^"cuim (Mute Cuica)" cuio^"cuio (Open Cuica)" trim^"trim (Mute Triangle)"
\break
	trio^"trio (Open Triangle)" r2
	\bar "|."
	}

 \score {
    <<
      \new DrumStaff \with {
	drumStyleTable =  #(alist->hash-table mydrums-style2)
	\override DrumStaff #'TimeSignature #'style = #'()
        fontSize = #1
        \override StaffSymbol #'staff-space = #(magstep 1)
      }
      <<
	\set Staff.instrumentName = "Drums"
	\override Score.MetronomeMark #'extra-offset = #'(-10 . 1.5)
	\pulse
      >>
    >>

  \layout {
	\context { \RemoveEmptyStaffContext }
  }
  \midi {
    \context {
      \Score
      tempoWholesPerMinute = #(ly:make-moment 60 4)
      }
    }
	} % fin du score


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Ballade-rock."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #" N'oubliez pas de personnaliser les vélocités après votre copier-coller.
 
 Don't forget to customise the velocities after your copy and paste."
	} }

  \include "ballade-rock-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Big Beat."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Big-Beat-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Biguine."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Biguine-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Blues."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Blues-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Boogie-woogie."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "boogie-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Bossa nova."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "bossanova-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Cha-cha-cha."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Cha-cha-cha-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Country."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Country-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Dance."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Dance-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Disco."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Disco-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Dubstep / Grime."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Dubstep--Grime-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Funk."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "funk-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Hip-Hop.A very simple hip hop beat:"

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Hip-Hop-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Jungle, Drum and Bass."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Jungle--Drum-and-Bass-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Rap."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "rap-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Rock."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "Rock-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Salsa."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "salsa-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Slow-rock."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "slow-rock-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Swing."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #" N'oubliez pas de personnaliser les vélocités après votre copier-coller. Prenez soin des notes fantômes.
 
 Don't forget to customise the velocities after your copy and paste. Be careful about the ghost notes."
	} }

  \include "swing-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "2-step Garage."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "two-step-Garage-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \pageBreak
  \titledPiece \markup "Valses."

	\markup { \fill-line { \override #'(line-width . 80)
 \justify-string #""
	} }

  \include "valses-patterns.ly"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  \pageBreak
%  \titledPiece \markup ""

%	\markup { \fill-line { \override #'(line-width . 80)
% \justify-string #""
%	} }

%  \include ""

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

